// Created by ../Docs/generate_cpp_docs_from_html_docs.py
#include "pysvn_docs.hpp"

const char copyright_doc[] =
   "Copyright (c) 2003-2007 Barry A Scott.  All rights reserved.\n"
   "\n"
   " This software is licensed as described in the file LICENSE.txt,\n"
   " which you should have received as part of this distribution.\n"
   "\n"
   " =============================================================\n"
   "\n"
   " This product includes software developed by\n"
   " CollabNet (http://www.Collab.Net/).\n"
;

const char pysvn_client_doc[] =
   "Interface summary:\n"
   "\n"
   "client = pysvn.Client()\n"
   "client = pysvn.Client( config_dir )\n"
   "\n"
   "The default subversion configuration directory is used if the\n"
   "config_dir is omitted or set to ''.\n"
   "\n"
   "The configuration directory is automatically created if it is\n"
   "missing.\n"
   "\n"
   "A Client object can only be used on one thread at a time. If\n"
   "two threads attempt to call methods of Client at the same time\n"
   "one of the threads will get a pysvn.ClientError exception with\n"
   "the value 'client in use on another thread'.\n"
   "Variables Callbacks Methods\n"
;

const char pysvn_client_add_doc[] =
   "add( path,\n"
   "     recurse=True,\n"
   "     force=False,\n"
   "     ignore=False,\n"
   "     depth=None )\n"
   "add( [path,path],\n"
   "     recurse=True,\n"
   "     force=False,\n"
   "     ignore=True,\n"
   "     depth=None )\n"
   "\n"
   "Schedules all the files or directories specfied in the paths\n"
   "for addition to the repository. Set recurse to True to recursively\n"
   "add a directory's children.Set force to True to force\n"
   "operation to run.Set ignore to False to\n"
   "disregard default and svn:ignore property ignores.Files are added at the next checkin.\n"
   "\n"
   "The depth can be used as in place of recurse. depth is one of the pysvn.depth enums.\n"
;

const char pysvn_client_add_to_changelist_doc[] =
   "add_to_changelist( path,\n"
   "                   changelist,\n"
   "                   depth=QQQ,\n"
   "                   changelists=[] )\n"
   "\n"
   "TBD\n"
   "\n"
   "depth is one of the pysvn.depth enums.\n"
;

const char pysvn_client_annotate_doc[] =
   "file_annotation = \\\n"
   "annotate( url_or_path,\n"
   "          revision_start=pysvn.Revision( opt_revision_kind.number, 0 ),\n"
   "          revision_end=pysvn.Revision( opt_revision_kind.head ),\n"
   "          peg_revision=pysvn.Revision( opt_revision_kind.unspecified ) )\n"
   " )\n"
   "\n"
   "Return the annotation for each line in the url_or_path from\n"
   "revision_start to revision_end.\n"
   "\n"
   "peg_revision indicates in\n"
   "which revision url_or_path is valid.  If peg_revision.kind\n"
   "is opt_revision_kind.unspecified, then it defaults to\n"
   "opt_revision_kind.head for URLs or opt_revision_kind.working for\n"
   "WC targets.\n"
   "\n"
   "The file_annotation is a list of dictionaries. Each dictionary\n"
   "contains:\n"
   "* author - string - the name of the author who last wrote the line\n"
   "* date - string - the date of the last change to the line\n"
   "* line - string - the text of the line\n"
   "* number - int - the line number\n"
   "* revision - pysvn.Revision - the revision that committed the line\n"
;

const char pysvn_client_callback_cancel_doc[] =
   "import pysvn\n"
   "\n"
   "cancel_command = False\n"
   "def cancel():\n"
   "    return cancel_command\n"
   "\n"
   "client = pysvn.Client()\n"
   "client.callback_cancel = cancel\n"
   "\n"
   "The callback_cancel function is called frequently during long\n"
   "running commands. Return True to cause the command to cancel,\n"
   "return False to allow the command to continue.\n"
;

const char pysvn_client_callback_get_log_message_doc[] =
   "import pysvn\n"
   "\n"
   "log_message = \"reason for change\"\n"
   "def get_log_message():\n"
   "    return rc, log_message\n"
   "\n"
   "client = pysvn.Client()\n"
   "client.callback_get_log_message = get_log_message\n"
   "\n"
   "The callback_get_log_message is called when a log message is\n"
   "required to complete the current command. Return the True in rc\n"
   "and a log message as a string. Returning False in rc will cause\n"
   "the command to be cancelled. An empty log_message is not allowed\n"
   "and may cause the command to be cancelled.\n"
   "\n"
   "Unicode strings cannot be handled. If you have a unicode string,\n"
   "convert it to UTF-8.\n"
;

const char pysvn_client_callback_get_login_doc[] =
   "import pysvn\n"
   "\n"
   "def get_login( realm, username, may_save ):\n"
   "    return retcode, username, password, save\n"
   "\n"
   "client = pysvn.Client()\n"
   "client.callback_get_login = get_login\n"
   "\n"
   "callback_get_login is called each time subversion needs a \n"
   "username and password in the realm to access a repository and\n"
   "has no cached credentials.\n"
   "\n"
   "The may_save parameter is true if subversion is willing to\n"
   "save the answers returned by the callback_get_login function.\n"
   "\n"
   "pysvn expect the callback_get_login to return a tuple of\n"
   "four values (retcode, username, password, save).\n"
   "* retcode - boolean, False if no username and password are\n"
   "  available. True if subversion is to use the username and password.\n"
   "* username - string, the username to use\n"
   "* password - string, the password to use\n"
   "* save - boolean, return True if you want subversion to remember\n"
   "  the username and password in the configuration directory.\n"
   "  return False to prevent saving the username and password.\n"
;

const char pysvn_client_callback_notify_doc[] =
   "import pysvn\n"
   "\n"
   "def notify( event_dict ):\n"
   "    return\n"
   "\n"
   "client = pysvn.Client()\n"
   "client.callback_notify = notify\n"
   "\n"
   "The callback_notify is called as a command runs each time an\n"
   "interesting event occurs. The details of the event are passed to\n"
   "the callback_notify function as a dictionary.\n"
   "\n"
   "The dictionary contains the following values:\n"
   "* path - the path of the action refers to\n"
   "* action - the events action, one of thewc_notify_action values\n"
   "* kind - the node kind, one of the pysvn.node_kind values\n"
   "* mime_type - the mime type\n"
   "* content_state - one of the pysvn.wc_notify_state values\n"
   "* prop_state - one of the pysvn.wc_notify_state values\n"
   "* revision - a Revision object\n"
;

const char pysvn_client_callback_ssl_client_cert_password_prompt_doc[] =
   "import pysvn\n"
   "\n"
   "def ssl_client_cert_password_prompt( realm, may_save ):\n"
   "    return retcode, password, save\n"
   "\n"
   "client = pysvn.Client()\n"
   "client.callback_ssl_client_cert_password_prompt = ssl_client_cert_password_prompt\n"
   "\n"
   "callback_ssl_client_cert_password_prompt is called each time\n"
   "subversion needs a password in the realm to use a client\n"
   "certificate and has no cached credentials.\n"
   "\n"
   "The may_save parameter is true if subversion is willing to save\n"
   "the answers returned by the callback_ssl_client_cert_password_prompt\n"
   "function.\n"
   "\n"
   "pysvn expect the callback_ssl_client_cert_password_prompt to\n"
   "return a tuple of three values (retcode, password, save).\n"
   "* retcode - boolean, False if no password is available.\n"
   "True if subversion is to use password.\n"
   "* password - string, the password to use\n"
   "* save - boolean, return True if you want subversion to remember\n"
   "the password in the configuration directory. return False to\n"
   "prevent saving the password.\n"
;

const char pysvn_client_callback_ssl_client_cert_prompt_doc[] =
   "import pysvn\n"
   "\n"
   "def ssl_client_cert_prompt( realm, may_save ):\n"
   "    return retcode, certfile, may_save\n"
   "\n"
   "client = pysvn.Client()\n"
   "client.callback_ssl_client_cert_prompt = ssl_client_cert_prompt\n"
   "\n"
   "callback_ssl_client_cert_prompt is called each time subversion\n"
   "needs a client certificate.\n"
   "\n"
   "pysvn expect the callback_ssl_client_cert_prompt to return a\n"
   "tuple of three values (retcode, certfile, may_save).\n"
   "* retcode - boolean, False if no certificate is available.\n"
   "True if subversion is to use the certificate.\n"
   "* certfile - string, the certfile to use\n"
;

const char pysvn_client_callback_ssl_server_prompt_doc[] =
   "import pysvn\n"
   "\n"
   "def ssl_server_prompt( ):\n"
   "    return \n"
   "\n"
   "client = pysvn.Client()\n"
   "client.callback_ssl_server_prompt = ssl_server_prompt\n"
   "\n"
   "NOT IMPLEMENTED - what it used for?\n"
;

const char pysvn_client_callback_ssl_server_trust_prompt_doc[] =
   "import pysvn\n"
   "\n"
   "def ssl_server_trust_prompt( trust_dict ):\n"
   "    return retcode, accepted_failures, save\n"
   "\n"
   "client = pysvn.Client()\n"
   "client.callback_ssl_server_trust_prompt = ssl_server_trust_prompt\n"
   "\n"
   "The callback_ssl_server_trust_prompt is called each time an\n"
   "HTTPS server presents a certificate and subversion is not sure\n"
   "if it should be trusted. callback_ssl_server_trust_prompt is\n"
   "called with information about the certificate in trust dict.\n"
   "* failures - int - a bitmask of failures - [What do these\n"
   "  bits mean?]\n"
   "* hostname - string - the hostname the certificate was\n"
   "  presented from\n"
   "* finger_print - string - certificate finger print\n"
   "* valid_from - string - valid from this ISO8601 date\n"
   "* valid_until - string - valid util this ISO8601 date\n"
   "* issuer_dname - stirng - the issued dname\n"
   "* realm - string - the realm\n"
   "\n"
   "pysvn expect the callback_ssl_server_trust_prompt to return\n"
   "a tuple of three values (retcode, accepted_failures, save).\n"
   "* retcode - boolean, False if no username and password are\n"
   "  available. True if subversion is to use the username and password.\n"
   "* accepted_failures - int, the accepted failures allowed\n"
   "* save - boolean, return True if you want subversion to remember\n"
   "  the certificate in the configuration directory. return False\n"
   "  to prevent saving the certificate.\n"
;

const char pysvn_client_callbacks_doc[] =
   "pysvn uses callback functions to allow for realtime feedback\n"
   "and credential handling.\n"
   "\n"
   "callback_cancel allows you to cancel a long running subversion command.\n"
   "\n"
   "callback_notify gives feedback as commands runs.\n"
   "\n"
   "callback_get_log_message is called when a log message is required.\n"
   "\n"
   "callback_get_login is called to get a username and password to access a repository.\n"
   "\n"
   "callback_ssl_server_trust_prompt is called when using HTTPS to a server whoes certificate needs is trust verifing.\n"
   "\n"
   "It is possible to use the Client object without setting up any\n"
   "calls backs. Make sure that all nessesary usernames, passwords and\n"
   "SSL certificate information are stored in the subversion\n"
   "configuration directory.\n"
;

const char pysvn_client_cat_doc[] =
   "file_text = \\\n"
   "cat( url_or_path,\n"
   "     revision=pysvn.Revision( opt_revision_kind.head ),\n"
   "     peg_revision=pysvn.Revision( opt_revision_kind.unspecified ) )\n"
   "\n"
   "Return the contents of url_or_path for the specified revision as\n"
   "a string, file_text.\n"
   "\n"
   "peg_revision indicates in\n"
   "which revision url_or_path is valid.  If peg_revision.kind\n"
   "is opt_revision_kind.unspecified, then it defaults to\n"
   "opt_revision_kind.head for URLs or opt_revision_kind.working for\n"
   "WC targets.\n"
;

const char pysvn_client_checkin_doc[] =
   "revision = \\\n"
   "checkin( path,\n"
   "        log_message,\n"
   "        recurse=True,\n"
   "        keep_locks=False,\n"
   "        depth,\n"
   "        keep_changelist,\n"
   "        changelists,\n"
   "        revprops )\n"
   "revision = \\\n"
   "checkin( [path,path],\n"
   "        log_message,\n"
   "        recurse=True,\n"
   "        keep_locks=False,\n"
   "        depth,\n"
   "        keep_changelist,\n"
   "        changelists,\n"
   "        revprops )\n"
   "\n"
   "checkin the files in the path_list to the repository with the\n"
   "specifed log_message. Set recurse to True to recursively checkin\n"
   "a directory's children with the same log message.Set\n"
   "keep_locks to True to prevent locks in the path being unlocked.\n"
   "\n"
   "checkin returns a pysvn.Revision containing the number of the\n"
   "checked in revision.\n"
   "\n"
   "depth,\n"
   "        keep_changelist,\n"
   "        changelists,\n"
   "        revprops TBD\n"
;

const char pysvn_client_checkout_doc[] =
   "revision = \\\n"
   "checkout( url,\n"
   "          path,\n"
   "          recurse=True,\n"
   "          revision=pysvn.Revision( opt_revision_kind.head ),\n"
   "          peg_revision=pysvn.Revision( opt_revision_kind.unspecified ),\n"
   "          ignore_externals=False )\n"
   "\n"
   "checkout the repository at url into the location specified by path.\n"
   "Set recurse to True to recursively check out a directory's children.\n"
   "Specify a revision to check out a particular version of the source\n"
   "tree.Set ignore_externals to True to ignore externals definitions.\n"
   "\n"
   "peg_revision indicates in\n"
   "which revision url is valid.  If peg_revision.kind\n"
   "is opt_revision_kind.unspecified, then it defaults to\n"
   "opt_revision_kind.head for URLs or opt_revision_kind.working for\n"
   "WC targets.\n"
   "\n"
   "checkout returns a pysvn.Revision containing the number of the\n"
   "checked out revision.\n"
   "\n"
   "Note: Subversion seems to return 0 rather then the actual revision.\n"
   "Use a notify callback and record the revision reported for thepysvn .wc_notify_action.update_completed event.\n"
   "This is what the svn command does.\n"
;

const char pysvn_client_cleanup_doc[] =
   "cleanup( path )\n"
   "\n"
   "Clean up any locks in the working copy at path. Usually such\n"
   "locks are the result of a failed or interrupted operation.\n"
;

const char pysvn_client_copy_doc[] =
   "copy( src_url_or_path,\n"
   "      dest_url_or_path,\n"
   "      src_revision=pysvn.Revision( opt_revision_kind.head ))\n"
   "\n"
   "Duplicate something in working copy or repos, remembering history.\n"
   "The src_revision defaults to pysvn.Revision( opt_revision_kind.head )\n"
   "if the src_path is a URL otherwise to\n"
   "pysvn.Revision( opt_revision_kind.working ).\n"
   "\n"
   "src_url_or_path and dest_url_or_path can each be either a\n"
   "working copy (WC) path or URL:* WC  -> WC:   copy and schedule for addition (with history)\n"
   "* WC  -> URL:  immediately commit a copy of WC to URL\n"
   "* URL -> WC:   check out URL into WC, schedule for addition\n"
   "* URL -> URL:  complete server-side copy; used to branch and tag\n"
   "\n"
   "\n"
   "If the destination is a URL theclient_get_log_message callback must be implemented to return a log message.\n"
;

const char pysvn_client_copy2_doc[] =
   "copy2( sources,\n"
   "       dest_url_or_path,\n"
   "       copy_as_child=False,\n"
   "       make_parents=False,\n"
   "       revprops )\n"
   "\n"
   "Duplicate something in working copy or repos, remembering history.\n"
   "The src_revision defaults to pysvn.Revision( opt_revision_kind.head )\n"
   "if the src_path is a URL otherwise to\n"
   "pysvn.Revision( opt_revision_kind.working ).\n"
   "\n"
   "revprops TBD\n"
   "\n"
   "src_url_or_path and dest_url_or_path can each be either a\n"
   "working copy (WC) path or URL:* WC  -> WC:   copy and schedule for addition (with history)\n"
   "* WC  -> URL:  immediately commit a copy of WC to URL\n"
   "* URL -> WC:   check out URL into WC, schedule for addition\n"
   "* URL -> URL:  complete server-side copy; used to branch and tag\n"
   "\n"
   "\n"
   "If the destination is a URL theclient_get_log_message callback must be implemented to return a log message.\n"
;

const char pysvn_client_diff_doc[] =
   "diff_text = \\\n"
   "diff( tmp_path,\n"
   "      url_or_path,\n"
   "      revision1=pysvn.Revision( opt_revision_kind.base ),\n"
   "      url_or_path2=url_or_path,\n"
   "      revision2=pysvn.Revision( opt_revision_kind.working ),\n"
   "      recurse=True,\n"
   "      ignore_ancestry=False,\n"
   "      diff_deleted=True,\n"
   "      ignore_content_type=False,\n"
   "      header_encoding=\"\",\n"
   "      diff_options=[],\n"
   "      depth=depth )\n"
   "\n"
   "Return the differences between revision1 of url_or_path\n"
   "and revision2 of url_or_path2. diff_text is a string\n"
   "containing the diff output.\n"
   "\n"
   "diff uses tmp_path to form the filename when creating any temporary\n"
   "files needed. The names are formed using tmp_path + unique_string + \".tmp\".\n"
   "For example tmp_path=/tmp/diff_prefix will create files like\n"
   "/tmp/diff_prefix.tmp and /tmp/diff_prefix1.tmp.\n"
   "\n"
   "Diff output will not be generated for binary files, unless\n"
   "ignore_content_type is true, in which case diffs will be shown\n"
   "regardless of the content types.\n"
   "\n"
   "Generated headers are encoded using header_encoding.\n"
   "\n"
   "The list of diff_options strings are passed to the external\n"
   "diff program that subversion uses. Typical options are\n"
   "-b (ignore space changes) and -w (ignore all white space).\n"
   "The exact options that work depend on the version of subversion used\n"
   "and its configuration.\n"
   "\n"
   "The depth can be used as in place of recurse. depth is one of the pysvn.depth enums.\n"
;

const char pysvn_client_diff_peg_doc[] =
   "diff_text = \\\n"
   "diff_peg( tmp_path,\n"
   "          url_or_path,\n"
   "          peg_revision=pysvn.Revision( opt_revision_kind.unspecified ),\n"
   "          revision_start=pysvn.Revision( opt_revision_kind.base ),\n"
   "          revision_end=pysvn.Revision( opt_revision_kind.working ),\n"
   "          recurse=True,\n"
   "          ignore_ancestry=False,\n"
   "          diff_deleted=True,\n"
   "          ignore_content_type=False,\n"
   "          header_encoding=\"\",\n"
   "          diff_options=[],\n"
   "          depth=depth )\n"
   "\n"
   "return the differences between two revisions of the url_or_path.\n"
   "diff_text is a string containing the diff output.\n"
   "\n"
   "diff uses tmp_path to form the filename when creating any temporary\n"
   "files needed. The names are formed using tmp_path + unique_string + \".tmp\".\n"
   "For example tmp_path=/tmp/diff_prefix will create files like\n"
   "/tmp/diff_prefix.tmp and /tmp/diff_prefix1.tmp.\n"
   "\n"
   "Set recurse to True to recursively diff a directory's children.\n"
   "diff_text is a string containing the diff.\n"
   "\n"
   "The depth can be used as in place of recurse. depth is one of the pysvn.depth enums.\n"
   "\n"
   "peg_revision indicates in which revision url_or_path is valid.\n"
   "If peg_revision.kind is opt_revision_kind.unspecified, then it\n"
   "defaults to opt_revision_kind.head for URLs or\n"
   "opt_revision_kind.working for WC targets.\n"
   "\n"
   "Diff output will not be generated for binary files, unless\n"
   "ignore_content_type is true, in which case diffs will be shown\n"
   "regardless of the content types.\n"
   "\n"
   "Generated headers are encoded using header_encoding.\n"
   "\n"
   "The list of diff_options strings are passed to the external\n"
   "diff program that subversion uses. Typical options are\n"
   "-b (ignore space changes) and -w (ignore all white space).\n"
   "The exact options that work depend on the version of subversion used\n"
   "and its configuration.\n"
;

const char pysvn_client_diff_summarize_doc[] =
   "summary = \\\n"
   "diff_summarize( url_or_path1,\n"
   "                revision1=pysvn.Revision( opt_revision_kind.base ),\n"
   "                url_or_path2=url_or_path,\n"
   "                revision2=pysvn.Revision( opt_revision_kind.working ),\n"
   "                recurse=True,\n"
   "                ignore_ancestry=False,\n"
   "                depth=depth )\n"
   "\n"
   "Produce a diff summary which lists the changed items between\n"
   "url_or_path1 revision1 and url_or_path2 revision2 without creating text\n"
   "deltas. url_or_path1 and url_or_path2 can be either working-copy paths or URLs.\n"
   "\n"
   "The function may report false positives if ignore_ancestry is False,\n"
   "since a file might have been modified between two revisions, but still\n"
   "have the same contents.\n"
   "\n"
   "The depth can be used as in place of recurse. depth is one of the pysvn.depth enums.\n"
;

const char pysvn_client_diff_summarize_peg_doc[] =
   "diff_text = \\\n"
   "diff_summarize_peg( url_or_path,\n"
   "                    peg_revision=pysvn.Revision( opt_revision_kind.unspecified ),\n"
   "                    revision_start=pysvn.Revision( opt_revision_kind.base ),\n"
   "                    revision_end=pysvn.Revision( opt_revision_kind.working ),\n"
   "                    recurse=True,\n"
   "                    ignore_ancestry=False,\n"
   "                    depth=depth )\n"
   "\n"
   "Produce a diff summary which lists the changed items between the\n"
   "filesystem object url_or_path in peg revision peg_revision, as it\n"
   "changed between revision_start and revision_end.  url_or_path can\n"
   "be either a working-copy path or URL.\n"
   "\n"
   "If peg_revision is opt_revision_unspecified, behave\n"
   "identically to svn_client_diff_summarize(), using path for both\n"
   "of that function's url_or_path1 and url_or_path2 argments.\n"
   "\n"
   "The function may report false positives if ignore_ancestry is False,\n"
   "as described in the documentation for diff_summarize().\n"
   "\n"
   "The depth can be used as in place of recurse. depth is one of the pysvn.depth enums.\n"
;

const char pysvn_client_exception_style_doc[] =
   "exception_style is used to control how pysvn raisesClientError exceptions.\n"
   "\n"
   "The default value, 0, makes pysvn raise exceptions as it did prior\n"
   "to pysvn 1.1.2.\n"
   "\n"
   "exception_style can be set to 0 or 1, seeClientError for details of effect of the style on the exception raised.\n"
;

const char pysvn_client_export_doc[] =
   "revision = \\\n"
   "export( src_url_or_path,\n"
   "        dest_path,\n"
   "        force=False,\n"
   "        revision=pysvn.Revision(),\n"
   "        native_eol=None,\n"
   "        ignore_externals=False,\n"
   "        recurse=True,\n"
   "        peg_revision=pysvn.Revision( opt_revision_kind.unspecified ),\n"
   "        depth=depth )\n"
   "\n"
   "Create an unversioned copy of the src_path at revision in dest_path.Set recurse to False to export a single file. Set ignore_externals to\n"
   "True to ignore externals definitions.\n"
   "\n"
   "peg_revision indicates in\n"
   "which revision src_url_or_path is valid.  If peg_revision.kind\n"
   "is opt_revision_kind.unspecified, then it defaults to\n"
   "opt_revision_kind.head for URLs or opt_revision_kind.working for\n"
   "WC targets.\n"
   "* Exports a clean directory tree from the repository specified by\n"
   "  URL src_url_or_path, at revision if it is given, otherwise at\n"
   "  HEAD, into dest_path.\n"
   "* Exports a clean directory tree from the working copy specified\n"
   "  by src_path into dest_path.  All local changes will be preserved,\n"
   "  but files not under revision control will not be copied.\n"
   "\n"
   "The depth can be used as in place of recurse. depth is one of the pysvn.depth enums.\n"
   "\n"
   "native_eol parameter allows the line ending of files with\n"
   "svn:eol-style propery set to native to be overriden.\n"
   "Use None to use the eol-style of the Operating System,\n"
   "use \"LF\" to use \"\\n\", \"CR\" to use \"\\r\" and \"CRLF\" to use \"\\r\\n\".\n"
   "\n"
   "export returns a pysvn.Revision containing the number of the\n"
   "checked in revision.\n"
   "\n"
   "Note: The native_eol parameter is only available for svn 1.1.0\n"
   "or later.\n"
;

const char pysvn_client_get_adm_dir_doc[] =
   "name = get_adm_dir()\n"
   "\n"
   "Returns the name of the subverion admin directory.\n"
;

const char pysvn_client_get_auth_cache_doc[] =
   "enabled = get_auth_cache()\n"
   "\n"
   "return true if credential caching is enabled, otherwise return\n"
   "false.\n"
;

const char pysvn_client_get_auto_props_doc[] =
   "enabled = get_auto_props()\n"
   "\n"
   "Returns true if svn will automatically set properties\n"
   "when adding files, otherwise returns false.\n"
;

const char pysvn_client_get_changelist_doc[] =
   "changelist_list = \\\n"
   "get_changelist( path,\n"
   "                changelist,\n"
   "                depth=depth,\n"
   "                changelists=[] )\n"
   "\n"
   "TBD\n"
   "\n"
   "The depth is one of the pysvn.depth enums.\n"
;

const char pysvn_client_get_default_password_doc[] =
   "password = get_default_password()\n"
   "\n"
   "Returns None if no default is set otherwise returns the password as a string.\n"
;

const char pysvn_client_get_default_username_doc[] =
   "username = get_default_username()\n"
   "\n"
   "Returns None if no default is set otherwise returns the username as a string.\n"
;

const char pysvn_client_get_interactive_doc[] =
   "enabled = get_interactive()\n"
   "\n"
   "Returns true if svn will prompt for missing credential information, otherwise returns false.\n"
;

const char pysvn_client_get_store_passwords_doc[] =
   "enabled = get_store_passwords()\n"
   "\n"
   "Returns true if svn will store passwords after prompting for them, otherwise returns false.\n"
;

const char pysvn_client_import__doc[] =
   "revision = \\\n"
   "import_( path,\n"
   "         url,\n"
   "         log_message,\n"
   "         recurse=True,\n"
   "         ignore=False,\n"
   "         revprops )\n"
   "\n"
   "Commit an unversioned file or tree into the repository.\n"
   "\n"
   "Recursively commit a copy of PATH to URL.\n"
   "Parent directories are created as necessary in the repository.Set ignore to False to\n"
   "disregard default and svn:ignore property ignores.\n"
   "\n"
   "revprops TBD\n"
   "\n"
   "import_ returns a pysvn.Revision containing the number of the\n"
   "checked in revision.\n"
;

const char pysvn_client_info_doc[] =
   "entry = info( path )\n"
   "\n"
   "return information on path as aEntry object.\n"
;

const char pysvn_client_info2_doc[] =
   "entry_list = \\\n"
   "info2( url_or_path,\n"
   "       revision=pysvn.Revision( opt_revision_kind.unspecified ),\n"
   "       peg_revision=pysvn.Revision( opt_revision_kind.unspecified ),\n"
   "       recurse=True,\n"
   "       depth=depth )\n"
   "\n"
   "\n"
   "return information on url_or_path as a list of (path, info_dict)\n"
   "tuples. To return information about a URL revision must be\n"
   "opt_revision_kind.head or opt_revision_kind.number.\n"
   "\n"
   "peg_revision indicates in\n"
   "which revision url_or_path is valid.  If peg_revision.kind\n"
   "is opt_revision_kind.unspecified, then it defaults to\n"
   "opt_revision_kind.head for URLs or opt_revision_kind.working for\n"
   "WC targets.\n"
   "\n"
   "The depth can be used as in place of recurse. depth is one of the pysvn.depth enums.\n"
   "\n"
   "The info_dict contains:* URL - URL or path\n"
   "* rev - pysvn.Revision or None\n"
   "* kind - kind of path\n"
   "* repos_root_URL - string\n"
   "* repos_UUID - string\n"
   "* last_changed_rev - pysvn.Revision or None\n"
   "* last_changed_date - time or None\n"
   "* last_changed_author - string or None\n"
   "* lock - None or dictionary containing:\n"
   "* path - string\n"
   "* token - string or None\n"
   "* owner - string or None\n"
   "* comment - string or None\n"
   "* is_dav_comment - true if is DAV comment\n"
   "* creation_date - time or None\n"
   "* wc_info - None if url_or_path is a URL; \n"
   "  otherwise a dictionary containing:\n"
   "* schedule - pysvn.wc_schedule or None\n"
   "* copyfrom_url - string or None\n"
   "* copyfrom_rev - pysvn.Revision or None\n"
   "* text_time - time or None\n"
   "* prop_time - time or None\n"
   "* checksum - string or None\n"
   "* conflict_old - string or None\n"
   "* conflict_new - string or None\n"
   "* conflict_wrk - string or None\n"
   "* prejfile - string or None\n"
   "\n"
   "\n"
   "Note: The info2 command is only available with svn 1.2.0 or later.\n"
;

const char pysvn_client_is_adm_dir_doc[] =
   "rc = \\\n"
   "is_adm_dir( name )\n"
   "\n"
   "Return True is the name is an subversion admin directory.\n"
;

const char pysvn_client_is_url_doc[] =
   "rc = \\\n"
   "is_url( url )\n"
   "\n"
   "return True if the url is a known subversion url.\n"
   "\n"
   "The PysvnList object obtains the lock information:\n"
   "* comment - string - the lock comment\n"
   "* token - string - lock token\n"
   "* path -\n"
   "* owner - string - owner of the lock\n"
   "* expiration_date - None or int - time lock will expire\n"
   "* is_dav_comment - boolean - true is a commment from DAV\n"
   "* creation_date - int - time the lock was created\n"
;

const char pysvn_client_list_doc[] =
   "entries_list = \\\n"
   "list( url_or_path,\n"
   "      peg_revision=pysvn.Revision( opt_revision_kind.unspecified ) )\n"
   "      revision=pysvn.Revision( opt_revision_kind.head ),\n"
   "      recurse=True,\n"
   "      dirent_fields=pysvn.SVN_DIRENT_ALL,\n"
   "      fetch_locks=False,\n"
   "      depth=depth )\n"
   "\n"
   "Returns a list with a tuple of information for each file in the given\n"
   "path at the provided revision.\n"
   "\n"
   "peg_revision indicates in which revision url_or_path is valid.\n"
   "If peg_revision.kind is opt_revision_kind.unspecified, then it\n"
   "defaults to opt_revision_kind.head for URLs or\n"
   "opt_revision_kind.working for WC targets.\n"
   "\n"
   "The depth can be used as in place of recurse. depth is one of the pysvn.depth enums.\n"
   "\n"
   "dirent_fields controls which dirent fields will return.\n"
   "Use pysvn.SVN_DIRENT_ALL to return all fields. Bit-wise or\n"
   "one of these values to return only the selected fields:\n"
   "* SVN_DIRENT_KIND - return kind field\n"
   "* SVN_DIRENT_SIZE - return size field\n"
   "* SVN_DIRENT_HAS_PROPS - return has_props field\n"
   "* SVN_DIRENT_CREATED_REV - return created_rev field\n"
   "* SVN_DIRENT_TIME - return time field\n"
   "* SVN_DIRENT_LAST_AUTHOR - return last_author field\n"
   "\n"
   "The tuple contains:\n"
   "* 0 - PysvnList containing the dirent information\n"
   "* 1 - PysvnLock containing the lock information or None\n"
   "\n"
   "The PysvnList object contains the requested dirent fields:\n"
   "* created_rev - pysvn.Revision - the revision of the last change\n"
   "* has_props - bool - True if the node has properties\n"
   "* kind - node_kind - one of the pysvn.node_kind values\n"
   "* last_author - string - the author of the last change\n"
   "* repos_path - string - (always present) absolute path of file in the repository\n"
   "* size - long - size of file\n"
   "* time - float - the time of the last change\n"
;

const char pysvn_client_lock_doc[] =
   "lock( url_or_path,\n"
   "      lock_comment, \n"
   "      force=False )\n"
   "\n"
   "lock the url_or_path with lock_comment. Set force to True to\n"
   "override any lock held by another user.\n"
;

const char pysvn_client_log_doc[] =
   "log_messages = \\\n"
   "log( url_or_path,\n"
   "     revision_start=pysvn.Revision( opt_revision_kind.head ),\n"
   "     revision_end=pysvn.Revision( opt_revision_kind.number, 0 ),\n"
   "     discover_changed_paths=False,\n"
   "     strict_node_history=True,\n"
   "     limit=0,\n"
   "     peg_revision=pysvn.Revision( opt_revision_kind.unspecified ),\n"
   "     include_merged_revisions=False,\n"
   "     revprops=list_of_revprop_names )\n"
   "\n"
   "Return the log messages for the specified url_or_path between\n"
   "revisions start and end.Set limit to the maximum number\n"
   "of log messages to be returned, 0 means return all messages.\n"
   "\n"
   "If discover_changed_paths is set, the changed_paths dictionary\n"
   "entry is filled with a list of changed paths.\n"
   "If strict_node_history is set, log entries will not cross copies.\n"
   "\n"
   "If url_or_path no longer exists in the repos of WC then pass in a peg_revision of a revision where it did exist.\n"
   "\n"
   "include_merged_revisions TBD\n"
   "\n"
   "revprops is a list of strings that name the revprops to be returned.\n"
   "\n"
   "log returns a list of log entries; each log entry is a\n"
   "dictionary. The dictionary contains:\n"
   "* author - string - the name of the author who committed the revision\n"
   "* date - float time - the date of the commit\n"
   "* message - string - the text of the log message for the commit\n"
   "* revision - pysvn.Revision - the revision of the commit\n"
   "* changed_paths - list of dictionaries. Each dictionary contains:\n"
   "* path - string - the path in the repository\n"
   "* action - string\n"
   "* copyfrom_path - string - if copied, the original path, else None\n"
   "* copyfrom_revision - pysvn.Revision - if copied, the revision of the original, else None\n"
;

const char pysvn_client_ls_doc[] =
   "entries_list = \\\n"
   "ls( url_or_path,\n"
   "    revision=pysvn.Revision( opt_revision_kind.head ),\n"
   "    recurse=True,\n"
   "    peg_revision=pysvn.Revision( opt_revision_kind.unspecified ) )\n"
   "\n"
   "Use thelist method in new code\n"
   "as it fixes performance and ambiguity problems with the ls method.\n"
   "\n"
   "Returns a list of dictionaries for each file the given path at\n"
   "the provided revision.\n"
   "\n"
   "peg_revision indicates in\n"
   "which revision url_or_path is valid.  If peg_revision.kind\n"
   "is opt_revision_kind.unspecified, then it defaults to\n"
   "opt_revision_kind.head for URLs or opt_revision_kind.working for\n"
   "WC targets.\n"
   "\n"
   "The dictionary contains:\n"
   "* created_rev - pysvn.Revision - the revision of the last change\n"
   "* has_props - bool - True if the node has properties\n"
   "* kind - node_kind - one of the pysvn.node_kind values\n"
   "* last_author - the author of the last change\n"
   "* name - string - name of the file\n"
   "* size - long - size of file\n"
   "* time - float - the time of the last change\n"
;

const char pysvn_client_merge_doc[] =
   "merge( url_or_path1,\n"
   "       revision1,\n"
   "       url_or_path2,\n"
   "       revision2,\n"
   "       local_path,\n"
   "       force=False,\n"
   "       recurse=True,\n"
   "       depth=depth,\n"
   "       record_only=False,\n"
   "       merge_options=[] )\n"
   "\n"
   "Apply the differences between two sources to a working copy path.\n"
   "\n"
   "The depth can be used as in place of recurse. depth is one of the pysvn.depth enums.\n"
;

const char pysvn_client_merge_peg_doc[] =
   "merge_peg( url_or_path,\n"
   "           revision1,\n"
   "           revision2,\n"
   "           peg_revision,\n"
   "           local_path,\n"
   "           recurse=True,\n"
   "           notice_ancestry,\n"
   "           force=False,\n"
   "           dry_run=False,\n"
   "           depth=depth,\n"
   "           record_only=False,\n"
   "           merge_options=[] )\n"
   "\n"
   "Apply the differences between two sources to a working copy path.\n"
   "\n"
   "peg_revision indicates in\n"
   "which revision url_or_path is valid.  If peg_revision.kind\n"
   "is opt_revision_kind.unspecified, then it defaults to\n"
   "opt_revision_kind.head for URLs or opt_revision_kind.working for\n"
   "WC targets.\n"
   "\n"
   "The depth can be used as in place of recurse. depth is one of the pysvn.depth enums.\n"
;

const char pysvn_client_merge_peg2_doc[] =
   "merge_peg2( sources,\n"
   "            ranges_to_merge,\n"
   "            peg_revision,\n"
   "            tareget_wcpath,\n"
   "            depth=depth,\n"
   "            notice_ancestry=False,\n"
   "            force=False,\n"
   "            dry_run=False,\n"
   "            record_only=True,\n"
   "            merge_options=[] )\n"
   "\n"
   "Apply the differences between the ranges_to_merge in sources to a working copy path, target_wcpath.\n"
   "ranges_to_merge is a list of tuples with the start and end revisions to be merged.\n"
   "\n"
   "peg_revision indicates in which revision url_or_path is valid.\n"
   "If peg_revision.kind is opt_revision_kind.unspecified, then it defaults to\n"
   "opt_revision_kind.head for URLs or opt_revision_kind.working for\n"
   "WC targets.\n"
   "\n"
   "The depth is one of the pysvn.depth enums.\n"
;

const char pysvn_client_methods_doc[] =
   "add add_to_changelist annotate cat checkin checkout cleanup copy copy2 diff diff_peg diff_summarize diff_summarize_peg export get_adm_dir get_auth_cache get_auto_props get_changelist get_default_password get_default_username get_interactive get_store_passwords import_ info info2 is_adm_dir is_url list log lock ls merge merge_peg merge_peg2 mkdir move copy2 propdel propget proplist propset relocate remove remove_from_changelists resolved revert revpropdel revpropget revproplist revpropset root_url_from_path set_adm_dir set_auth_cache set_auto_props set_default_password set_default_username set_interactive set_store_passwords status switch unlock update\n"
;

const char pysvn_client_mkdir_doc[] =
   "mkdir( url_or_path,\n"
   "       log_message,\n"
   "       make_parents,\n"
   "       revprops )\n"
   "mkdir( [url_or_path,url_or_path],\n"
   "       log_message,\n"
   "       make_parents,\n"
   "       revprops )\n"
   "\n"
   "Create a new directory under revision control.\n"
   "\n"
   "url_or_path can be a list of URLs and paths\n"
   "\n"
   "make_parents and revprops TBD\n"
   "\n"
   "If url_or_path is a path, each directory is scheduled for\n"
   "addition upon the next commit.\n"
   "\n"
   "If url_or_path is a URL, the directories are created in the\n"
   "repository via an immediate commit.\n"
   "\n"
   "In both cases, all the intermediate directories must already\n"
   "exist.\n"
;

const char pysvn_client_move_doc[] =
   "move( src_url_or_path,\n"
   "      dest_url_or_path,\n"
   "      force=False )\n"
   "\n"
   "Move (rename) something in working copy or HEAD revision of repository.\n"
   "\n"
   "NOTE: this command is equivalent to a 'copy' and 'delete'.\n"
   "\n"
   "src_path and dest_path can both be working copy (WC) paths\n"
   "or URLs:* WC  -> WC:   move and schedule for addition (with history)\n"
   "* URL -> URL:  complete server-side rename.\n"
   "\n"
   "\n"
   "If src_url_or_path is a path, each item is scheduled for deletion\n"
   "upon the next commit.  Files, and directories that have not been\n"
   "committed, are immediately removed from the working copy.  The\n"
   "command will not remove PATHs that are, or contain, unversioned\n"
   "or modified items; set force=True to override this\n"
   "behaviour.\n"
   "\n"
   "If src_url_or_path is a URL, the items are deleted from the\n"
   "repository via an immediate commit.\n"
;

const char pysvn_client_move2_doc[] =
   "move2( sources,\n"
   "       dest_url_or_path,\n"
   "       move_as_child=False,\n"
   "       make_parents=False,\n"
   "       revprops )\n"
   "\n"
   "Duplicate something in working copy or repos, remembering history.\n"
   "The src_revision defaults to pysvn.Revision( opt_revision_kind.head )\n"
   "if the src_path is a URL otherwise to\n"
   "pysvn.Revision( opt_revision_kind.working ).\n"
   "\n"
   "revprops TBD\n"
   "\n"
   "src_url_or_path and dest_url_or_path can each be either a\n"
   "working copy (WC) path or URL:* WC  -> WC:   move and schedule for addition (with history)\n"
   "* WC  -> URL:  immediately commit a move of WC to URL\n"
   "* URL -> WC:   check out URL into WC, schedule for addition\n"
   "* URL -> URL:  complete server-side move; used to branch and tag\n"
   "\n"
   "\n"
   "If the destination is a URL theclient_get_log_message callback must be implemented to return a log message.\n"
;

const char pysvn_client_propdel_doc[] =
   "rev = \\\n"
   "propdel( prop_name,\n"
   "         url_or_path,\n"
   "         revision=pysvn.Revision(),\n"
   "         recurse=False,\n"
   "         skip_checks=False,\n"
   "         depth=depth,\n"
   "         revprops )\n"
   "\n"
   "Delete the property prop_name from url_or_path.\n"
   "\n"
   "If  skip_checks is true, do no validity checking.  But if \n"
   "skip_checks is false, and  propname is not a valid property for \n"
   "target, return an error, either  SVN_ERR_ILLEGAL_TARGET (if the\n"
   "property is not appropriate for  target), or \n"
   "SVN_ERR_BAD_MIME_TYPE (if  propname is \"svn:mime-type\", but \n"
   "propval is not a valid mime-type).\n"
   "\n"
   "The src_revision defaults to\n"
   "pysvn.Revision( opt_revision_kind.head ) if the src_path is a\n"
   "URL otherwise to pysvn.Revision( opt_revision_kind.working ).\n"
   "\n"
   "The depth can be used as in place of recurse. depth is one of the pysvn.depth enums.\n"
   "\n"
   "revprops TBD\n"
;

const char pysvn_client_propget_doc[] =
   "prop_list = \\\n"
   "propget( prop_name,\n"
   "         url_or_path,\n"
   "         revision=pysvn.Revision(),\n"
   "         recurse=False,\n"
   "         peg_revision=pysvn.Revision( opt_revision_kind.unspecified ),\n"
   "         depth=depth )\n"
   "\n"
   "Returns a dictionary with keys of url_or_path and values of\n"
   "the prop_name.\n"
   "\n"
   "The src_revision defaults to pysvn.Revision( opt_revision_kind.head )\n"
   "if the url_or_path is a URL otherwise to\n"
   "pysvn.Revision( opt_revision_kind.working ).\n"
   "\n"
   "peg_revision indicates in\n"
   "which revision url_or_path is valid.  If peg_revision.kind\n"
   "is opt_revision_kind.unspecified, then it defaults to\n"
   "opt_revision_kind.head for URLs or opt_revision_kind.working for\n"
   "WC targets.\n"
   "\n"
   "The depth can be used as in place of recurse. depth is one of the pysvn.depth enums.\n"
;

const char pysvn_client_proplist_doc[] =
   "prop_list = \\\n"
   "proplist( url_or_path,\n"
   "          revision=pysvn.Revision(),\n"
   "          recurse=False,\n"
   "          peg_revision=pysvn.Revision( opt_revision_kind.unspecified ),\n"
   "          depth=depth )\n"
   "\n"
   "Returns a list of tuples (path, prop_dict). The prop_dict\n"
   "contains the prop_names and their values if set on the path.\n"
   "\n"
   "The src_revision defaults to pysvn.Revision( opt_revision_kind.head )\n"
   "if the url_or_path is a URL otherwise to\n"
   "pysvn.Revision( opt_revision_kind.working ).\n"
   "\n"
   "peg_revision indicates in\n"
   "which revision url_or_path is valid.  If peg_revision.kind\n"
   "is opt_revision_kind.unspecified, then it defaults to\n"
   "opt_revision_kind.head for URLs or opt_revision_kind.working for\n"
   "WC targets.\n"
   "\n"
   "The depth can be used as in place of recurse. depth is one of the pysvn.depth enums.\n"
;

const char pysvn_client_propset_doc[] =
   "commit_info = \\propset( prop_name,\n"
   "         prop_value,\n"
   "         url_or_path,\n"
   "         revision=pysvn.Revision(),\n"
   "         recurse=False,\n"
   "         skip_checks=False,\n"
   "         depth=depth,\n"
   "         allow_unver_obstructions=False,\n"
   "         revprops )\n"
   "\n"
   "Set the property prop_name to prop_value in url_or_path.\n"
   "\n"
   "If skip_checks is true, do no validity checking.  But if \n"
   "skip_checks is false, and  propname is not a valid property for \n"
   "target, return an error, either  SVN_ERR_ILLEGAL_TARGET (if the\n"
   "property is not appropriate for  target), or \n"
   "SVN_ERR_BAD_MIME_TYPE (if  propname is \"svn:mime-type\", but \n"
   "propval is not a valid mime-type).\n"
   "\n"
   "The revision defaults to pysvn.Revision( opt_revision_kind.head )\n"
   "if the url_or_path is a URL otherwise to\n"
   "pysvn.Revision( opt_revision_kind.working ).\n"
   "\n"
   "The depth can be used as in place of recurse. depth is one of the pysvn.depth enums.\n"
   "\n"
   "If allow_unver_obstructions is False then the update will abort\n"
   "if there are any unversioned obstructing items.\n"
   "\n"
   "revprops TBD\n"
;

const char pysvn_client_relocate_doc[] =
   "relocate( from_url,\n"
   "          to_url,\n"
   "          path,\n"
   "          recurse=True,\n"
   "          depth=depth )\n"
   "\n"
   "Relocate the working copy from from_url to to_url of path.\n"
   "\n"
   "The depth can be used as in place of recurse. depth is one of the pysvn.depth enums.\n"
;

const char pysvn_client_remove_doc[] =
   "remove( url_or_path_list,\n"
   "        force=False,\n"
   "        keep_local=False,\n"
   "        revprops )\n"
   "\n"
   "If url_or_path is a path, each item is scheduled for deletion\n"
   "upon the next commit.  Files, and directories that have not been\n"
   "committed, are immediately removed from the working copy.  The\n"
   "command will not remove paths that are, or contain, unversioned\n"
   "or modified items; set force=True to override this\n"
   "behaviour.\n"
   "\n"
   "Set keep_local to True to prevent the local file from being delete.\n"
   "\n"
   "revprops TBD\n"
   "\n"
   "If url_or_path is a URL, the items are deleted from the\n"
   "repository via an immediate commit.\n"
;

const char pysvn_client_remove_from_changelists_doc[] =
   "remove_from_changelists( path,\n"
   "                         changelist,\n"
   "                         depth=pysvn.depth.infinite,\n"
   "                         changelists=[] )\n"
   "\n"
   "TBD\n"
;

const char pysvn_client_resolved_doc[] =
   "resolved( path,\n"
   "          recurse=True,\n"
   "          depth=depth )\n"
   "\n"
   "Mark the conflicted file at path as resolved.\n"
   "\n"
   "The depth can be used as in place of recurse. depth is one of the pysvn.depth enums.\n"
;

const char pysvn_client_revert_doc[] =
   "revert( path,\n"
   "        recurse=False,\n"
   "        depth=depth )\n"
   "revert( [path,path],\n"
   "        recurse=False,\n"
   "        depth=depth )\n"
   "\n"
   "Discard any changes in the working copy at path.\n"
   "Set recurse to True to recursively revert a directory's children.\n"
   "\n"
   "The depth can be used as in place of recurse. depth is one of the pysvn.depth enums.\n"
;

const char pysvn_client_revpropdel_doc[] =
   "rev = \\\n"
   "revpropdel( prop_name,\n"
   "            url,\n"
   "            revision=pysvn.Revision( opt_revision_kind.head ),\n"
   "            force=False )\n"
   "\n"
   "Delete the revision property prop_name from url.\n"
;

const char pysvn_client_revpropget_doc[] =
   "rev_prop = \\\n"
   "revpropget( prop_name,\n"
   "            url,\n"
   "            revision=pysvn.Revision( opt_revision_kind.head ) )\n"
   "\n"
   "Returns a tuple (rev, prop_val) where the prop_val contains\n"
   "the revision property value.\n"
;

const char pysvn_client_revproplist_doc[] =
   "rev_prop_dict = \\\n"
   "revproplist( url,\n"
   "             revision=pysvn.Revision( opt_revision_kind.head ) )\n"
   "\n"
   "Returns a tuple (revision, prop_dict) where the prop_dict\n"
   "contains the revision properies and their values.\n"
;

const char pysvn_client_revpropset_doc[] =
   "rev = \\\n"
   "revpropset( prop_name,\n"
   "            prop_value,\n"
   "            url,\n"
   "            revision=pysvn.Revision( opt_revision_kind.head ),\n"
   "            force=False )\n"
   "\n"
   "set the revision property prop_name to prop_value in path.\n"
   "The revision updated is returned.\n"
;

const char pysvn_client_root_url_from_path_doc[] =
   "root_url = \\\n"
   "    root_url_from_path( url_or_path )\n"
   "\n"
   "Return the root URL of the repository given the url_or_path.\n"
;

const char pysvn_client_set_adm_dir_doc[] =
   "set_adm_dir( name )\n"
   "\n"
   "Set the name of the subverion admin directory. \".svn\" is the normal admin dir use and \"_svn\" is used on Windows to work around problems with .NET.\n"
;

const char pysvn_client_set_auth_cache_doc[] =
   "set_auth_cache( enable )\n"
   "\n"
   "When enable is True subversion will remember authentication credentials\n"
   "in the configuration directory.\n"
;

const char pysvn_client_set_auto_props_doc[] =
   "set_auto_props( enable )\n"
   "\n"
   "When enabled, subversion will automatically set properties\n"
   "when adding files; otherwise when disabled it will not.\n"
;

const char pysvn_client_set_default_password_doc[] =
   "set_default_password( password )\n"
   "\n"
   "Set the default password to be used if there is no stored password.\n"
;

const char pysvn_client_set_default_username_doc[] =
   "set_default_username( username )\n"
   "\n"
   "Set the default username to be used if there is no stored username.\n"
;

const char pysvn_client_set_interactive_doc[] =
   "set_interactive( enable )\n"
   "\n"
   "When enable is True subversion will prompt for authentication credentials\n"
   "when there are no valid store credentials.\n"
;

const char pysvn_client_set_store_passwords_doc[] =
   "set_store_passwords( enable )\n"
   "\n"
   "When enable is True subversion will store any passwords that subversion prompted for.\n"
;

const char pysvn_client_status_doc[] =
   "status_list = \\\n"
   "status( path,\n"
   "        recurse=True,\n"
   "        get_all=True,\n"
   "        update=False,\n"
   "        ignore=False,\n"
   "        ignore_externals=False,\n"
   "        depth=depth )\n"
   "\n"
   "If path is a directory status is returned for all files in the\n"
   "directory in status_list. If path is a single file status is\n"
   "returned for that single file in status_list.Set ignore_externals to True to ignore externals definitions.\n"
   "\n"
   "The status_list is a list ofPysvnStatus objects.\n"
   "\n"
   "Options:* recurse - If recurse is True, recurse fully, else do only\n"
   "  immediate children.\n"
   "* get_all - If get_all is True, retrieve all entries; otherwise,\n"
   "  retrieve only \"interesting\" entries (local mods and/or out-of-date).\n"
   "* update - If update is set, contact the repository and augment the\n"
   "  status structures with information about out-of-dateness.\n"
   "* ignore - If ignore is False, the item will be added regardless of\n"
   "  whether it is ignored.\n"
   "* ignore_externals (svn 1.2.0 or later) - \n"
   "  If ignore_externals is False, then recurse into externals\n"
   "  definitions (if any exist) after handling the main target. \n"
   "  This calls the client notification function\n"
   "  with the svn_wc_notify_status_external action before \n"
   "  handling each externals definition, and with \n"
   "  svn_wc_notify_status_completed after each.\n"
   "* \n"
   "depth - can be used as in place of recurse. depth is one of the pysvn.depth enums.\n"
;

const char pysvn_client_switch_doc[] =
   "switch( path,\n"
   "        url,\n"
   "        recurse=True,\n"
   "        revision=pysvn.Revision( opt_revision_kind.head ),\n"
   "        depth=depth )\n"
   "\n"
   "Update the working copy to a different URL.\n"
   "\n"
   "The depth can be used as in place of recurse. depth is one of the pysvn.depth enums.\n"
   "* Update the working copy to mirror a new URL. This behaviour is a\n"
   "  superset of \"svn update\".\n"
   "  Note:  this is the way to move a working copy to a new branch.\n"
   "* Reconnect the working copy when the repository URL has changed.\n"
;

const char pysvn_client_unlock_doc[] =
   "unlock( url_or_path,\n"
   "        force=False )\n"
   "\n"
   "Unlock the url_or_path. Set force to True to unlock any lock\n"
   "held by another user.\n"
;

const char pysvn_client_update_doc[] =
   "revision = \\\n"
   "update( path,\n"
   "        recurse=True,\n"
   "        revision=pysvn.Revision( opt_revision_kind.head ),\n"
   "        ignore_externals=False,\n"
   "        depth=depth )\n"
   "\n"
   "Update the file in the working copy at path to the specified\n"
   "revision. Set recurse to True to recursively update a directory's\n"
   "children.Set ignore_externals to True to ignore externals definitions.\n"
   "\n"
   "The depth can be used as in place of recurse. depth is one of the pysvn.depth enums.\n"
   "\n"
   "update returns a pysvn.Revision containing the number of the\n"
   "revision the working copy was updated to.\n"
   "\n"
   "This command is typically used to get the latest changes\n"
   "from the repository.\n"
   "\n"
   "Note: updating to an older revision does not change the \n"
   "current revision. To make the current version identical to\n"
   "an older revision, use a merge followed by a commit.\n"
;

const char pysvn_client_variables_doc[] =
   "exception_style allows you to control the style of exception raised by pysvn.\n"
;

const char pysvn_clienterror_doc[] =
   "ClientError exception is raised when any of the subversion\n"
   "functions called by pysvn return an error.\n"
   "\n"
   "TheClient .exception_style variable controls the information stored in the ClientError object.\n"
;

const char pysvn_depth_doc[] =
   "* empty - Just the named directory D, no entries.  Updates will not pull in\n"
   "     any files or subdirectories not already present.\n"
   "* exclude - not used yet\n"
   "* files - D + its file children, but not subdirs.  Updates will pull in any\n"
   "     files not already present, but not subdirectories.\n"
   "* immediates - D + immediate children (D and its entries).  Updates will pull in\n"
   "     any files or subdirectories not already present; those\n"
   "     subdirectories' this_dir entries will have depth-empty.\n"
   "* infinity - D + all descendants (full recursion from D).  Updates will pull\n"
   "     in any files or subdirectories not already present; those\n"
   "     subdirectories' this_dir entries will have depth-infinity.\n"
   "     Equivalent to the pre-1.5 default update behavior.\n"
   "* unknown - Depth undetermined or ignored\n"
   "\n"
   "Copyright  2004-2008 Barry A. Scott. All rigths reserved.\n"
;

const char pysvn_entry_doc[] =
   "* checksum - string\n"
   "* commit_author - string\n"
   "* commit_revision - pysvn.Revision \n"
   "* commit_time - time\n"
   "* conflict_new - string or None - file path\n"
   "* conflict_old - string of None - file path\n"
   "* conflict_work - string of None - file path\n"
   "* copy_from_revision - pysvn.Revision or None\n"
   "* copy_from_url - string or None\n"
   "* is_absent - boolean\n"
   "* is_copied - boolean\n"
   "* is_deleted - boolean\n"
   "* is_valid - boolean\n"
   "* kind - pysvn.node_kind \n"
   "* name - string\n"
   "* properties_time - time\n"
   "* property_reject_file - string or None\n"
   "* repos - string\n"
   "* revision - pysvn.Revision or None\n"
   "* schedule - pysvn.wc_schedule or None\n"
   "* text_time - time\n"
   "* url - string or None\n"
   "* uuid - string or None\n"
;

const char pysvn_module_doc[] =
   "The pysvn module has the following variables:\n"
   "* pysvn.copyright - the pysvn copyright string\n"
   "* pysvn.version - the pysvn version as a tuple,\n"
   "    (major, minor, patch, build)\n"
   "* pysvn.svn_version - subversion version as a tuple\n"
   "    (major, minor, micro, tag)\n"
   "\n"
   "The pysvn module has six classes:\n"
   "* Client - the subversion client interface\n"
   "* Transaction - the subversion transaction interface\n"
   "* Revision - subversion revision objects\n"
   "* ClientError - Exception class raised by client commands on error\n"
   "* PysvnStatus - subversion status object\n"
   "* PysvnEntry - subversion entry object\n"
   "\n"
   "The following enumerations are provided:\n"
   "* opt_revision_kind - kinds of Revision object\n"
   "* wc_notify_action - see Client.callback_notify\n"
   "* wc_status_kind - see Client.status()\n"
   "* wc_schedule - see Client.status()\n"
   "* wc_merge_outcome - see Client.Merge()\n"
   "* wc_notify_state - see Client.callback_notify\n"
   "* node_kind - see Client.status() and Client.ls()\n"
   "* depth - replacement for recurse\n"
   "\n"
   "Use python builtin dir() to list all available values in an enumeration:\n"
   "\n"
   "    print dir( pysvn.wc_notify_action )\n"
;

const char pysvn_node_kind_doc[] =
   "* none - absent\n"
   "* file - regular file\n"
   "* dir - directory\n"
   "* unknown - something's here, but we don't know what\n"
;

const char pysvn_opt_revision_kind_doc[] =
   "* unspecified - No revision information given.\n"
   "* number - revision given as number\n"
   "* date - revision given as date\n"
   "* committed - rev of most recent change\n"
   "* previous - (rev of most recent change) - 1\n"
   "* base - .svn/entries current revision\n"
   "* working - current, plus local mods\n"
   "* head - repository youngest\n"
;

const char pysvn_revision_doc[] =
   "The Revision object has three member variables:\n"
   "* kind   - the kind of revision, its value is one of theopt_revision_kind enumerations.\n"
   "* date   - date and time when kind is opt_revision_kind.date,\n"
   "  as seconds since the epoch which is compatible with python's\n"
   "  time module.\n"
   "* number - revision number when kind is opt_revision_kind.number\n"
   "\n"
   "Interface summary:\n"
   "\n"
   "import pysvn\n"
   "import time\n"
   "\n"
   "revhead = pysvn.Revision( pysvn.opt_revision_kind.head )\n"
   "revdate = pysvn.Revision( pysvn.opt_revision_kind.date, time.time() )\n"
   "revnum = pysvn.Revision( pysvn.opt_revision_kind.number, 4721 )\n"
;

const char pysvn_status_doc[] =
   "Each status object has the following fields:\n"
   "* path - string - the path name\n"
   "* entry -PysvnEntry - entry information\n"
   "* is_versioned - Boolean - true if the path is versioned\n"
   "* is_locked - Boolean - true if the path is locked\n"
   "* is_copied - Boolean - true if the path is copied\n"
   "* is_switched - Boolean - true if the path has been switched\n"
   "* prop_status -wc_status_kind - the status of the properties\n"
   "  of the path\n"
   "* text_status -wc_status_kind - the status of the text of\n"
   "  the path\n"
   "* repos_prop_status -wc_status_kind - the repository status\n"
   "  of the properties of the path\n"
   "* repos_text_status -wc_status_kind - the repository status\n"
   "  of the text of the path\n"
   "* repos_lock - dict - the repository lock\n"
   "  information\n"
;

const char pysvn_transaction_doc[] =
   "Interface summary:\n"
   "\n"
   "transaction = pysvn.Transaction()\n"
   "transaction = pysvn.Transaction( repos_path, transaction_name )\n"
   "\n"
   "The Transaction object allows you to implement hook code for\n"
   "the SVN repository. The pre-commit and pre-revprop-change hooks\n"
   "are the only hooks that are currently appropriate in SVN. See \n"
   "the SVN documentation for details on hook scripts.\n"
   "\n"
   "A Transaction object can only be used on one thread at a time.\n"
   "If two threads attempt to call methods of Transaction at the same\n"
   "time one of the threads will get a pysvn.TransactionError exception\n"
   "with the value 'transaction in use on another thread'.\n"
;

const char pysvn_transaction_cat_doc[] =
   "file_text = \\\n"
   "cat( path )\n"
   "\n"
   "Return the contents of path as a string, file_text.\n"
;

const char pysvn_transaction_changed_doc[] =
   "file_text = \\\n"
   "changed( [copy_info=False] )\n"
   "\n"
   "Return a dict of all changes in the transaction. The keys in\n"
   "the dict are the path names and the values are tuples contraining\n"
   "action, kind, text_mod, prop_mod.\n"
   "\n"
   "The optional copy_info parameter when True will return the copy from revision and copy from path information.\n"
   "* action - string - a single letter indicating the action\n"
   "  'A' for add, 'R' for modify, 'D' for delete\n"
   "* kind - node_kind - one of the pysvn.node_kind values\n"
   "* text_mod - int - is != 0 if the text in this path has been\n"
   "  modified\n"
   "* prop_mod - int - is != 0 if the properties in this path\n"
   "  have been modified\n"
   "* copyfrom_rev - int - when path has been copied this is its copy from revision number\n"
   "* copyfrom_path - int - when path has been copied this is its copy from path\n"
;

const char pysvn_transaction_methods_doc[] =
   "cat changed propdel propget proplist propset revpropdel revpropget revproplist revpropset\n"
;

const char pysvn_transaction_propdel_doc[] =
   "propdel( prop_name,\n"
   "         path )\n"
   "\n"
   "Delete the property prop_name from path in the transaction.\n"
;

const char pysvn_transaction_propget_doc[] =
   "prop_value = \\\n"
   "propget( prop_name,\n"
   "         path )\n"
   "\n"
   "Returns the prop_value as a string or None if the prop_name\n"
   "is not in the transaction.\n"
;

const char pysvn_transaction_proplist_doc[] =
   "prop_dict = \\\n"
   "proplist( path )\n"
   "\n"
   "Returns a prop_dict. \n"
   "The prop_dict contains the prop_names and their values if set\n"
   "on the path in the transaction.\n"
;

const char pysvn_transaction_propset_doc[] =
   "propset( prop_name,\n"
   "         prop_value,\n"
   "         path )\n"
   "\n"
   "Set the property prop_name to prop_value in path in the transaction.\n"
;

const char pysvn_transaction_revpropdel_doc[] =
   "revpropdel( prop_name )\n"
   "\n"
   "Delete the revision property prop_name in the transaction.\n"
;

const char pysvn_transaction_revpropget_doc[] =
   "prop_val = \\\n"
   "revpropget( prop_name )\n"
   "\n"
   "Returns the prop_val with the revision property value or None if not set in the transaction.\n"
;

const char pysvn_transaction_revproplist_doc[] =
   "prop_dict = \\\n"
   "revproplist()\n"
   "\n"
   "Returns a prop_dict where the prop_dict contains the revision\n"
   "properies and their values in the transaction.\n"
;

const char pysvn_transaction_revpropset_doc[] =
   "rev = \\\n"
   "revpropset( prop_name,\n"
   "            prop_value )\n"
   "\n"
   "set the revision property prop_name to prop_value in path in\n"
   "the transaction. The revision updated is returned.\n"
;

const char pysvn_wc_merge_outcome_doc[] =
   "* unchanged - The working copy is (or would be) unchanged.\n"
   "The changes to be merged were already present in the working copy\n"
   "* merged - The working copy has been (or would be) changed.\n"
   "* conflict - The working copy has been (or would be) changed,\n"
   "but there was (or would be) a conflict\n"
   "* no_merge - No merge was performed, probably because the target\n"
   "file was either absent or not under version control.\n"
;

const char pysvn_wc_notify_action_doc[] =
   "* add - Adding a path to revision control.\n"
   "* copy - Copying a versioned path.\n"
   "* delete - Deleting a versioned path.\n"
   "* restore - Restoring a missing path from the pristine text-base.\n"
   "* revert - Reverting a modified path.\n"
   "* failed_revert - A revert operation has failed.\n"
   "* resolved - Resolving a conflict.\n"
   "* skip - Skipping a path.\n"
   "* update_delete - Got a delete in an update.\n"
   "* update_add - Got an add in an update.\n"
   "* update_update - Got any other action in an update.\n"
   "* update_completed - The last notification in an update (including updates of externals).\n"
   "* update_external - Updating an external module.\n"
   "* status_completed - The last notification in a status (including status on externals).\n"
   "* status_external - Running status on an external module.\n"
   "* commit_modified - Committing a modification.\n"
   "* commit_added - Committing an addition.\n"
   "* commit_deleted - Committing a deletion.\n"
   "* commit_replaced - Committing a replacement.\n"
   "* commit_postfix_txdelta - Transmitting post-fix text-delta data for a file.\n"
   "* annotate_revision - Processed a single revision's blame.\n"
   "* locked - Locking a path.\n"
   "* unlocked - Unlocking a path.\n"
   "* failed_lock - Failed to lock a path.\n"
   "* failed_unlock - Failed to unlock a path.\n"
;

const char pysvn_wc_notify_state_doc[] =
   "* inapplicable - inapplicable\n"
   "* unknown - Notifier doesn't know or isn't saying.\n"
   "* unchanged - The state did not change.\n"
   "* missing - The item wasn't present.\n"
   "* obstructed - An unversioned item obstructed work.\n"
   "* changed - Pristine state was modified.\n"
   "* merged - Modified state had mods merged in.\n"
   "* conflicted - Modified state got conflicting mods.\n"
;

const char pysvn_wc_schedule_doc[] =
   "* normal - Nothing special here\n"
   "* add - Slated for addition\n"
   "* delete - Slated for deletion\n"
   "* replace - Slated for replacement (delete + add)\n"
;

const char pysvn_wc_status_kind_doc[] =
   "* none - does not exist\n"
   "* unversioned - is not a versioned thing in this wc\n"
   "* normal - exists, but uninteresting.\n"
   "* added - is scheduled for addition\n"
   "* missing - under v.c., but is missing\n"
   "* deleted - scheduled for deletion\n"
   "* replaced - was deleted and then re-added\n"
   "* modified - text or props have been modified\n"
   "* merged - local mods received repos mods\n"
   "* conflicted - local mods received conflicting repos mods\n"
   "* ignored - a resource marked as ignored\n"
   "* obstructed - an unversioned resource is in the way of the versioned resource\n"
   "* external - an unversioned path populated by an svn:external property\n"
   "* incomplete - a directory doesn't contain a complete entries list\n"
;
